class Array
  def multithreads_each(options={})
    threads = []
    without_joins = options[:without_joins]

    self.each do |n|
      threads << Thread.new { yield n }
    end

    threads.each { |thread| thread.join } unless without_joins
  end
end
